package com.ejie.ab63.model.OTC;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * OficinasTecnicas  
 * 
 *  
 */

public class OficinasTecnicas implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idOficinaTecnica;
	private Zonas zonas;
	private BigDecimal subvencionSolicitada;
	private BigDecimal subvencionAdmitida;
	private Date fechaInicio;
	private String materiales;
	private String economicos;
	private String personales;
	private String nombreResponsable;
	private BigDecimal remuneacionEconomica;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificaion;
	private String usuarioUltmodificaion;

	/**
	 * Method 'OficinasTecnicas'.
	 */
	public OficinasTecnicas() {
	}

	/**
	 * Method 'OficinasTecnicas'.
	 * 
	 * @param idOficinaTecnica
	 *            Integer
	 */
	public OficinasTecnicas(Integer idOficinaTecnica) {
		this.idOficinaTecnica = idOficinaTecnica;
	}

	/**
	 * Method 'OficinasTecnicas'.
	 * 
	 * @param idOficinaTecnica
	 *            Integer
	 * @param subvencionSolicitada
	 *            BigDecimal
	 * @param subvencionAdmitida
	 *            BigDecimal
	 * @param fechaInicio
	 *            Date
	 * @param materiales
	 *            String
	 * @param economicos
	 *            String
	 * @param personales
	 *            String
	 * @param nombreResponsable
	 *            String
	 * @param remuneacionEconomica
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificaion
	 *            Date
	 * @param usuarioUltmodificaion
	 *            String
	 * @param zonas
	 *            Zonas
	 */
	public OficinasTecnicas(Integer idOficinaTecnica, BigDecimal subvencionSolicitada, BigDecimal subvencionAdmitida,
			Date fechaInicio, String materiales, String economicos, String personales, String nombreResponsable,
			BigDecimal remuneacionEconomica, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificaion,
			String usuarioUltmodificaion, Zonas zonas) {
		this.idOficinaTecnica = idOficinaTecnica;
		this.zonas = zonas;
		this.subvencionSolicitada = subvencionSolicitada;
		this.subvencionAdmitida = subvencionAdmitida;
		this.fechaInicio = fechaInicio;
		this.materiales = materiales;
		this.economicos = economicos;
		this.personales = personales;
		this.nombreResponsable = nombreResponsable;
		this.remuneacionEconomica = remuneacionEconomica;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificaion = fechaUltmodificaion;
		this.usuarioUltmodificaion = usuarioUltmodificaion;
	}

	/**
	 * Method 'getIdOficinaTecnica'.
	 *
	 * @return Integer
	 */

	public Integer getIdOficinaTecnica() {
		return this.idOficinaTecnica;
	}

	/**
	 * Method 'setIdOficinaTecnica'.
	 *
	 * @param idOficinaTecnica
	 *            Integer
	 * @return
	 */

	public void setIdOficinaTecnica(Integer idOficinaTecnica) {
		this.idOficinaTecnica = idOficinaTecnica;
	}

	/**
	 * Method 'getZonas'.
	 *
	 * @return Zonas
	 */
	@JsonIgnore

	public Zonas getZonas() {
		return this.zonas;
	}

	/**
	 * Method 'setZonas'.
	 *
	 * @param zonas
	 *            Zonas
	 * @return
	 */

	public void setZonas(Zonas zonas) {
		this.zonas = zonas;
	}

	/**
	 * Method 'getSubvencionSolicitada'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getSubvencionSolicitada() {
		return this.subvencionSolicitada;
	}

	/**
	 * Method 'setSubvencionSolicitada'.
	 *
	 * @param subvencionSolicitada
	 *            BigDecimal
	 * @return
	 */

	public void setSubvencionSolicitada(BigDecimal subvencionSolicitada) {
		this.subvencionSolicitada = subvencionSolicitada;
	}

	/**
	 * Method 'getSubvencionAdmitida'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getSubvencionAdmitida() {
		return this.subvencionAdmitida;
	}

	/**
	 * Method 'setSubvencionAdmitida'.
	 *
	 * @param subvencionAdmitida
	 *            BigDecimal
	 * @return
	 */

	public void setSubvencionAdmitida(BigDecimal subvencionAdmitida) {
		this.subvencionAdmitida = subvencionAdmitida;
	}

	/**
	 * Method 'getFechaInicio'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaInicio() {
		return this.fechaInicio;
	}

	/**
	 * Method 'setFechaInicio'.
	 *
	 * @param fechaInicio
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaInicio(Date fechaInicio) {
		this.fechaInicio = fechaInicio;
	}

	/**
	 * Method 'getMateriales'.
	 *
	 * @return String
	 */

	public String getMateriales() {
		return this.materiales;
	}

	/**
	 * Method 'setMateriales'.
	 *
	 * @param materiales
	 *            String
	 * @return
	 */

	public void setMateriales(String materiales) {
		this.materiales = materiales;
	}

	/**
	 * Method 'getEconomicos'.
	 *
	 * @return String
	 */

	public String getEconomicos() {
		return this.economicos;
	}

	/**
	 * Method 'setEconomicos'.
	 *
	 * @param economicos
	 *            String
	 * @return
	 */

	public void setEconomicos(String economicos) {
		this.economicos = economicos;
	}

	/**
	 * Method 'getPersonales'.
	 *
	 * @return String
	 */

	public String getPersonales() {
		return this.personales;
	}

	/**
	 * Method 'setPersonales'.
	 *
	 * @param personales
	 *            String
	 * @return
	 */

	public void setPersonales(String personales) {
		this.personales = personales;
	}

	/**
	 * Method 'getNombreResponsable'.
	 *
	 * @return String
	 */

	public String getNombreResponsable() {
		return this.nombreResponsable;
	}

	/**
	 * Method 'setNombreResponsable'.
	 *
	 * @param nombreResponsable
	 *            String
	 * @return
	 */

	public void setNombreResponsable(String nombreResponsable) {
		this.nombreResponsable = nombreResponsable;
	}

	/**
	 * Method 'getRemuneacionEconomica'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getRemuneacionEconomica() {
		return this.remuneacionEconomica;
	}

	/**
	 * Method 'setRemuneacionEconomica'.
	 *
	 * @param remuneacionEconomica
	 *            BigDecimal
	 * @return
	 */

	public void setRemuneacionEconomica(BigDecimal remuneacionEconomica) {
		this.remuneacionEconomica = remuneacionEconomica;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificaion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificaion() {
		return this.fechaUltmodificaion;
	}

	/**
	 * Method 'setFechaUltmodificaion'.
	 *
	 * @param fechaUltmodificaion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificaion(Date fechaUltmodificaion) {
		this.fechaUltmodificaion = fechaUltmodificaion;
	}

	/**
	 * Method 'getUsuarioUltmodificaion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificaion() {
		return this.usuarioUltmodificaion;
	}

	/**
	 * Method 'setUsuarioUltmodificaion'.
	 *
	 * @param usuarioUltmodificaion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificaion(String usuarioUltmodificaion) {
		this.usuarioUltmodificaion = usuarioUltmodificaion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idOficinaTecnica: ").append(this.idOficinaTecnica).append(" ]");
		result.append(", [ subvencionSolicitada: ").append(this.subvencionSolicitada).append(" ]");
		result.append(", [ subvencionAdmitida: ").append(this.subvencionAdmitida).append(" ]");
		result.append(", [ fechaInicio: ").append(this.fechaInicio).append(" ]");
		result.append(", [ materiales: ").append(this.materiales).append(" ]");
		result.append(", [ economicos: ").append(this.economicos).append(" ]");
		result.append(", [ personales: ").append(this.personales).append(" ]");
		result.append(", [ nombreResponsable: ").append(this.nombreResponsable).append(" ]");
		result.append(", [ remuneacionEconomica: ").append(this.remuneacionEconomica).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificaion: ").append(this.fechaUltmodificaion).append(" ]");
		result.append(", [ usuarioUltmodificaion: ").append(this.usuarioUltmodificaion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
